%define ocamlname conduit-lwt-unix

Name:           ocaml-%{ocamlname}
Version:        1.1.0
Release:        1%{?dist}.emp1
Summary:        the Lwt/Unix implementation of ocmal-conduit
License:        ISC
URL:            https://github.com/mirage/ocaml-%{ocaml-name}
Source0:        conduit-%{version}.tbz

Requires:  	ocaml >= 4.03.0
Requires:	ocaml-ppx_sexp_conv
Requires:	ocaml-conduit-lwt >= 1.1.0
Requires:	ocaml-lwt >=  3.0.0
Requires:	ocaml-lwt_ssl
Requires:	ocaml-uri >= 1.9.4
Requires:	ocaml-ipaddr >= 2.8.0

BuildRequires:  opam-installer >= 2.0
BuildRequires:  ocaml >= 4.03.0
BuildRequires:  jbuilder
BuildRequires:	ocaml-ppx_sexp_conv-devel
BuildRequires:	ocaml-conduit-lwt-devel >= 1.1.0
BuildRequires:	ocaml-lwt-devel >=  3.0.0
BuildRequires:	ocaml-lwt_ssl-devel
BuildRequires:	ocaml-uri-devel >= 1.9.4
BuildRequires:	ocaml-ipaddr-devel >= 2.8.0

%description
The `conduit` library takes care of establishing and listening for 
TCP and SSL/TLS connections for the Lwt and Async libraries.

The reason this library exists is to provide a degree of abstraction
from the precise SSL library used, since there are a variety of ways
to bind to a library (e.g. the C FFI, or the Ctypes library), as well
as well as which library is used (just OpenSSL for now).

By default, OpenSSL is used as the preferred connection library, but
you can force the use of the pure OCaml TLS stack by setting the
environment variable `CONDUIT_TLS=native` when starting your program.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:	ocaml-ppx_sexp_conv-devel
Requires:	ocaml-conduit-lwt-devel >= 1.1.0
Requires:	ocaml-lwt-devel >=  3.0.0
Requires:	ocaml-lwt_ssl-devel
Requires:	ocaml-uri-devel >= 1.9.4
Requires:	ocaml-ipaddr-devel >= 2.8.0

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n conduit-%{version}

%build
jbuilder subst
jbuilder build -p %{ocamlname}

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install

%check
jbuilder runtest -p %{ocamlname} %{?_smp_mflags}

%files
%doc %{_libdir}/ocaml/doc/%{ocamlname}/LICENSE.md
%{_libdir}/ocaml/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli

%files devel
%doc %{_libdir}/ocaml/doc/%{ocamlname}/CHANGES.md
%doc %{_libdir}/ocaml/doc/%{ocamlname}/README.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
